#ifndef MONSTER_H

#define MONSTER_H

#include "bitmap.h"

class Monster
{
public:

	char name[21];

	Bitmap pic;

	void changePalette(int);
	void copyImage(int);
	void copyPalette(int);
	void clearImage(void);
	void createBitmap(BYTE* = NULL);
	void createImage(void);
	void flipImage(int);
	void getDimensions(int*, int*);
	void getNewMold(void);
	void loadStats(BYTE *);
	void loadGraphics(void);
	void newImage(void);
	void saveSpecs(int);
	void setBitmap(Bitmap&);
	void setImage(int);
	void setNumColors(BYTE);
	int setPixel(int, int, BYTE);
	void setSize(int s);
	void setTransparency(BYTE);

	//Inline functions

	inline int getPalNum(void)
	{
		return palette;
	}
	inline BYTE getPixel(int x, int y)
	{
		return pic.getPixel(x, y);
	}
	inline BYTE getSize(void)
	{
		return size;
	}
	inline void decreaseImage(void)
	{
		imageNum--;
	}
	inline void decreaseMold(void)
	{
		mold--; createImage();
	}
	inline BYTE getColors(void)
	{
		return numColors;
	}
	inline int getImageNum(void)
	{
		return imageNum;
	}
	inline int getMoldNum(void)
	{
		return mold;
	}
	inline void setName(char *n)
	{
		strcpy(name, n);
	}

private:

	WORD imageNum;

	int palette;
	BYTE numColors;
	int mold;
	BYTE size;			//0 = 64x64 1 = 128x128

	WORD offset;		//offset to its graphics

	WORD calcSize(void);
};

#endif

